var csv = require("csv");
var fs = require("fs");

ComScriptWriter = function(config, parent) {
  this.config = config;
  this.parent = parent;
  this.refresh = this.config["refresh"];
  this.refreshSeconds = this.config["refresh_seconds"];
  this.initialized = false;

  $('body').addClass('writer');

  $("#save").click(this.saveValues.bind(this));

  $("#save").click(function(){
    var btn = $(this);
    btn.fadeOut('slow', function() { btn.fadeIn('slow'); })
  });

  this.tabContainer = $("#tab-container");
};

ComScriptWriter.prototype.afterRefresh = function() {
  if(this.initialized) return;

  // turn refresh off/on after initializing the form
  this.parent.refreshEnabled = this.refresh;
  this.initialized = true;
}

ComScriptWriter.prototype.configureField = function(field) {
  var elementType = "input";

  if(field.config["type"] == "select") {
    elementType = "select";
    field.html("<select class='form-control'></select>");
    $.each(field.config["options"], function(index, value) {
      field.find("select").append(
        "<option value='" + value + "'>" + value + "</option>");
    });
  }
  else if(field.config["type"] == "checkbox") {
    field.html("<input type='checkbox'>");
  }
  else if(field.config["type"] == "textbox") {
    field.html("<input type='text' class='form-control'>");
  }
	else if(field.config["type"] == "file") {
    field.html("<input type='text' disabled class='form-control'><input type='file' class='file-browser'>");
  }

  field.element = field.find(".value " + elementType).first();
}

ComScriptWriter.prototype.refreshField = function(field, value) {
  if(field.config["type"] == "checkbox")
    field.element.prop('checked', value == field.config["on_value"]);
  else
    field.element.val(value);
}

ComScriptWriter.prototype.saveValues = function() {
  var file = this.config["file"];

  var values = $.map(this.parent.panels, function(panel, index) {
    var data = panel.getFieldValues();
    // prepend the panel title
    data.unshift(panel.config["title"]);
    return [data];
  });

  csv.stringify(values, function(err, output){
    fs.writeFile(file, output);
  });

  this.scheduleRefresh();
}

ComScriptWriter.prototype.scheduleRefresh = function() {
  if(!this.refresh) return;

  setTimeout(
    this.parent.refreshValues.bind(this.parent),
    this.refreshSeconds * 1000
  );
}

module.exports = ComScriptWriter;
