/**
 * Build a 2-tiered list of command links and configure the onClick event for
 * each link to insert the XML for that command.
 */
function setupAttributes() {
  for(var command in attributes) {
    var markup = '<div class="attr-list '+command+'">';
    markup += "<strong>" + command + "</strong><br />";
    markup += "<ul>";
    for(var attribute in attributes[command]) {
      markup += "<li><a href='#' rel='" + command + ":" + attribute +   "' title='" + attributes[command][attribute]['description'] + "'>" + attribute + "</a></li>";
    }
    markup += "<li><a class='onfail' href='#' title='Continue execution when this command fails'>onfail</a></li>";

    markup += "</ul></div>";
    $('#attr-list').append(markup);
  }

  $('.attr-list').hide();

  $('#attr-list a').click(function() {
    var lineNum = editor.getCursor().line;
    var line = editor.getLine(lineNum);

    if($(this).hasClass('onfail')) {
      insertInCurrentTag('onfail="true"');
    } else {
      var parts = $(this).attr('rel').split(':');
      var regex = new RegExp(parts[1] + "\s*=");
      if(!line.match(regex)) {
        insertInCurrentTag(parts[1] + '="' + attributes[parts[0]][parts[1]]['default'] + '"');
      }
    }
    return false;
  });
}

function checkCommand() {
  if(!loading) {
    var lineNum = editor.getCursor().line;
    var line = editor.getLine(lineNum);
    var command = line.match(/<\w+/);
    if(command != null) {
      command = command.toString().substring(1);
      if(!$('.attr-list.' + command).is(':visible')) {
        $('.attr-list').hide();
        $('.attr-list.' + command).show();
      }
    } else {
      $('.attr-list').hide();
    }
  }
}

function showAttributeList(command) {
  $('.attr-list.' + command).show();
}
